package algorithms;

import java.util.ArrayList;
import java.util.List;
import objects.ClassifiableList;
import objects.Template;

public class ClassifierLinear extends Classifier {

    @Override
    public int classify(Template templateQuery, List<Template> templatesGallery) {
        List<Template> centroids = new ArrayList();
        List<List<Template>> templatesByClass = new ClassifiableList(templatesGallery).splitClasses();
        for (List<Template> templatesOfClass : templatesByClass) {
            Template centroid = new Template(0, "", null);
            if (templatesOfClass.isEmpty()) {
                System.out.println("empty class");
            } else {
                double minSum = Double.MAX_VALUE;
                for (Template centroidCandidate : templatesOfClass) {
                    double sum = 0;
                    for (Template template : templatesOfClass) {
                        sum += getDistance(template, centroidCandidate);
                    }
                    if (minSum > sum) {
                        minSum = sum;
                        centroid = centroidCandidate;
                    }
                }
            }
            centroids.add(centroid);
        }
        Template closestCentroid = new Template(0, "", null);
        double minDistance = Double.MAX_VALUE;
        for (Template centroid : centroids) {
            double distance = getDistance(centroid, templateQuery);
            if (minDistance > distance) {
                minDistance = distance;
                closestCentroid = centroid;
            }
        }
        return closestCentroid.getSubject();
    }
}
