package algorithms;

import objects.Template;

public final class DistanceTemplatesBaseline extends DistanceTemplates {

    private DistanceVectors poseDistance;

    public DistanceTemplatesBaseline() {
    }

    public void setDistanceVectors(DistanceVectors poseDistance) {
        this.poseDistance = poseDistance;
    }

    @Override
    public double getDistance(Template template1, Template template2) {
        int length = template1.getLength();
        if (length != template2.getLength()) {
            System.out.println("different lengths");
            template2.adjust(length);
        }
        double distance = 0;
        for (int l = 0; l < length; l++) {
            distance += Math.abs(poseDistance.getDistance(template1.getPose(l), template2.getPose(l)));
        }
        return distance;
    }
}
