package algorithms;

import Jama.Matrix;

public final class DistanceVectorsMahalanobis extends DistanceVectors {

    Matrix matrix;

    public DistanceVectorsMahalanobis() {
    }

    public void setMatrix(Matrix matrix) {
        this.matrix = matrix;
    }

    @Override
    public double getDistance(double[] pose1, double[] pose2) {
        int dimension = pose1.length;
        if (pose2.length != dimension || matrix.getColumnDimension() != dimension || matrix.getRowDimension() != dimension) {
            System.out.println("wrong dimensions");
        }
        Matrix diff = new Matrix(pose1,pose1.length).minus(new Matrix(pose2,pose2.length));
        return Math.sqrt(diff.transpose().times(matrix).times(diff).get(0, 0));
    }
}
