package algorithms;

import java.io.Serializable;
import java.util.List;
import objects.DistanceMatrix;
import objects.Template;

public abstract class Retriever implements Serializable {

    private DistanceTemplates distanceTemplates;
    private DistanceMatrix distanceMatrix;
    
    public Retriever() {
    }

    public void setDistanceTemplates(DistanceTemplates distanceTemplates) {
        this.distanceTemplates = distanceTemplates;
    }

    public void setDistanceMatrix(DistanceMatrix distanceMatrix) {
        this.distanceMatrix = distanceMatrix;
    }

    public abstract List<Template> retrieve(Template sampleTest, List<Template> samplesGallery);

    public double getDistance(Template template1, Template template2) {
        return distanceMatrix == null ? distanceTemplates.getDistance(template1, template2) : distanceMatrix.getDistance(template1, template2);
    }
}
