package methods;

import algorithms.Classifier1NN;
import algorithms.DistanceTemplatesDTW;
import algorithms.DistanceVectorsL1;
import executor.Executor;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import objects.Axis;
import objects.Feature;
import objects.Motion;
import objects.MotionJointCoordinates;

public class MethodJiang extends Method {

    public MethodJiang() {
    }

    @Override
    public Motion loadMotion(File fileAMC) throws IOException {
        return Executor.loadMotionJointCoordinates(fileAMC);
    }

    @Override
    public void learnClassifier(List<Motion> motionsLearning) {
        Classifier1NN classifier = new Classifier1NN();
        DistanceTemplatesDTW distanceTemplates = new DistanceTemplatesDTW();
        distanceTemplates.setDistanceVectors(new DistanceVectorsL1());
        classifier.setDistanceTemplates(distanceTemplates);
        setClassifier(classifier);
    }

    @Override
    public List<Feature> extractFeatures(Motion motion) {
        MotionJointCoordinates motionMJC = (MotionJointCoordinates) motion;
        List<Feature> features = new ArrayList();
        features.add(motionMJC.extractBoneAxisAngleFeature(new Axis("Y"), "rhipjoint", "rfemur"));
        features.add(motionMJC.extractBoneAxisAngleFeature(new Axis("Y"), "rfemur", "rtibia"));
        features.add(motionMJC.extractBoneAxisAngleFeature(new Axis("Y"), "rclavicle", "rhumerus"));
        features.add(motionMJC.extractBoneAxisAngleFeature(new Axis("Y"), "rhumerus", "rwrist"));
        return features;
    }
}
