package methods;

import algorithms.ClassifierRandom;
import algorithms.DistanceTemplatesRandom;
import executor.Executor;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import objects.Feature;
import objects.Motion;

public class Method_Random extends Method {

    public Method_Random() {
    }

    @Override
    public Motion loadMotion(File fileAMC) throws IOException {
        return Executor.loadMotionJointCoordinates(fileAMC);
    }

    @Override
    public void learnClassifier(List<Motion> motionsLearning) {
        ClassifierRandom classifier = new ClassifierRandom();
        classifier.setDistanceTemplates(new DistanceTemplatesRandom());
        setClassifier(classifier);
    }

    @Override
    public List<Feature> extractFeatures(Motion motion) {
        return new ArrayList();
    }
}
