package objects;

import java.util.ArrayList;
import java.util.List;

public class ClassifiableList <T extends Classifiable> {
    
    private final List<T> objects;

    public ClassifiableList(List<T> objects) {
        this.objects = objects;
    }

    public List<List<T>> splitClasses() {
        List<List<T>> objectsByClass = new ArrayList();
        for (T object : objects) {
            boolean classIsInObjectsByClass = false;
            for (List<T> objectsOfClass : objectsByClass) {
                if (objectsOfClass.get(0).getSubject() == object.getSubject()) {
                    classIsInObjectsByClass = true;
                    objectsOfClass.add(object);
                    break;
                }
            }
            if (!classIsInObjectsByClass) {
                List<T> objectOfClass = new ArrayList();
                objectOfClass.add(object);
                objectsByClass.add(objectOfClass);
            }
        }
        return objectsByClass;
    }
}
